For AI agents: a documentation index is available at the root level at /llms.txt and /llms-full.txt. Append /llms.txt to any URL for a page-level index, or .md for the markdown version of any page.
      • AstroFully-managed data operations, powered by Apache Airflow.
      • Astro Private CloudRun Airflow-as-a-service in your environment.
      • Professional ServicesExpert Airflow services for your enterprise's success.
    • Tools
      • Cosmos
      • Orbiter
      • CLI
      • AI SDK
      • Agents
      • Blueprint
      • UpdatesThe State of Airflow 2026See the insights from over 5,800 data practitioners in the full report. Download Now ➔
  • Customers
  • Docs
    • Insights
      • Blog
      • Webinars
      • Resource Library
      • Events
    • Education
      • Academy
      • What is Airflow?
  • Pricing
Get Started Free
  • Astro API v1
    • Overview
    • Get started
    • Versioning and support
    • Migrate to v1
    • Deploy with the API
  • API Reference
      • POSTCreate a custom role
      • DELDelete a custom role
      • GETGet a custom role
      • GETGet role templates
      • GETList roles
      • POSTUpdate custom role
    • Changelog
    • Book Office Hours

Product

  • Platform Overview
  • Astro
  • Astro Observe
  • Astro Private Cloud
  • Security & Trust
  • Pricing

Tools & Services

  • Cosmos
  • Docs
  • Professional Services
  • Product Updates

Use Cases

  • AI Ops
  • Data Observability
  • ETL/ELT
  • ML Ops
  • Operational Analytics
  • All Use Cases

Industries

  • Financial Services
  • Gaming
  • Retail
  • Manufacturing
  • Healthcare
  • All Industries

Resources

  • Academy
  • eBooks & Guides
  • Blog
  • Webinars
  • Events
  • The Data Flowcast Podcast
  • All Resources

Airflow

  • What is Airflow
  • Airflow on Astro
  • Airflow 3.0
  • Airflow Upgrades
  • Airflow Use Cases
  • Airflow 2.x End of Life

Company

  • Our Story
  • Customers
  • Newsroom
  • Careers
  • Contact

Support

  • Knowledge Base
  • Status
  • Contact Support
GitHubYouTubeLinkedInx
  • Legal
  • Privacy
  • Terms of Service
  • Consent Preferences

  • Do Not Sell or Share My Personal information
  • Limit the Use Of My Sensitive Personal Information

Apache Airflow®, Airflow, and the Airflow logo are trademarks of the Apache Software Foundation. Copyright © Astronomer 2026. All rights reserved.

LogoLogo
API ReferenceRole

Update custom role

POST
https://api.astronomer.io/v1/organizations/:organizationId/roles/:customRoleId
POST
/v1/organizations/:organizationId/roles/:customRoleId
$curl -X POST https://api.astronomer.io/v1/organizations/organizationId/roles/customRoleId \
> -H "Authorization: Bearer <token>" \
> -H "Content-Type: application/json" \
> -d '{
> "name": "Deployment_Viewer",
> "permissions": [
> "deployment.get"
> ]
>}'
1{
2 "createdAt": "2022-11-22T04:37:12Z",
3 "createdBy": {
4 "id": "clm8qv74h000008mlf08scq7k",
5 "apiTokenName": "my-token",
6 "avatarUrl": "https://avatar.url",
7 "fullName": "Jane Doe",
8 "subjectType": "USER",
9 "username": "user1@company.com"
10 },
11 "id": "cluc9tapx000901qn2xrgqdmn",
12 "name": "Deployment_Viewer",
13 "permissions": [
14 "deployment.get"
15 ],
16 "restrictedWorkspaceIds": [
17 "cldbvzoi20182g8odxt8ehi5i"
18 ],
19 "scopeType": "DEPLOYMENT",
20 "updatedAt": "2022-11-22T04:37:12Z",
21 "updatedBy": {
22 "id": "clm8qv74h000008mlf08scq7k",
23 "apiTokenName": "my-token",
24 "avatarUrl": "https://avatar.url",
25 "fullName": "Jane Doe",
26 "subjectType": "USER",
27 "username": "user1@company.com"
28 },
29 "description": "Subject can only view deployments."
30}
Update the metadata or included permissions for a custom role.
Was this page helpful?
Previous

Add members to a team

Next
Built with

Authentication

AuthorizationBearer

Bearer authentication of the form Bearer <token>, where token is your auth token.

Path parameters

organizationIdstringRequired
The ID of the Organization to which the role belongs.
customRoleIdstringRequired
The custom role's ID.

Request

The request body for updating the custom role.
namestringRequired
The role's name.
permissionslist of stringsRequired
The permissions included in the role.
descriptionstringOptional
The role's description.
restrictedWorkspaceIdslist of stringsOptional
The IDs of the Workspaces that the role is restricted to.

Response

OK
createdAtstringformat: "date-time"
The time the role was created.
createdByobject
idstring
The role's ID.
namestring
The role's name.
permissionslist of strings
The role's permissions.
restrictedWorkspaceIdslist of strings
The IDs of Workspaces that the role is restricted to.
scopeTypeenum
The role's scope.
Allowed values:
updatedAtstringformat: "date-time"
The time the role was last updated.
updatedByobject
descriptionstring
The role's description.

Errors

400
Bad Request Error
401
Unauthorized Error
403
Forbidden Error
404
Not Found Error
500
Internal Server Error